-- This file is part of broadcaster library
-- Licensed under MIT License
-- Copyright (c) 2019 Ranx
-- https://github.com/r4nx/broadcaster
-- Version 0.2.0

local charset = {}

charset.MESSAGE_ENCODE = {
    [' '] = 0,
    ['!'] = 1,
    ['"'] = 2,
    ['#'] = 3,
    ['$'] = 4,
    ['%'] = 5,
    ['&'] = 6,
    ['\''] = 7,
    ['('] = 8,
    [')'] = 9,
    ['*'] = 10,
    ['+'] = 11,
    [','] = 12,
    ['-'] = 13,
    ['.'] = 14,
    ['/'] = 15,
    [':'] = 16,
    [';'] = 17,
    ['<'] = 18,
    ['='] = 19,
    ['>'] = 20,
    ['?'] = 21,
    ['@'] = 22,
    ['['] = 23,
    ['\\'] = 24,
    [']'] = 25,
    ['^'] = 26,
    ['_'] = 27,
    ['`'] = 28,
    ['{'] = 29,
    ['|'] = 30,
    ['}'] = 31,
    ['~'] = 32,
    ['0'] = 33,
    ['1'] = 34,
    ['2'] = 35,
    ['3'] = 36,
    ['4'] = 37,
    ['5'] = 38,
    ['6'] = 39,
    ['7'] = 40,
    ['8'] = 41,
    ['9'] = 42,
    ['A'] = 43,
    ['B'] = 44,
    ['C'] = 45,
    ['D'] = 46,
    ['E'] = 47,
    ['F'] = 48,
    ['G'] = 49,
    ['H'] = 50,
    ['I'] = 51,
    ['J'] = 52,
    ['K'] = 53,
    ['L'] = 54,
    ['M'] = 55,
    ['N'] = 56,
    ['O'] = 57,
    ['P'] = 58,
    ['Q'] = 59,
    ['R'] = 60,
    ['S'] = 61,
    ['T'] = 62,
    ['U'] = 63,
    ['V'] = 64,
    ['W'] = 65,
    ['X'] = 66,
    ['Y'] = 67,
    ['Z'] = 68,
    ['a'] = 69,
    ['b'] = 70,
    ['c'] = 71,
    ['d'] = 72,
    ['e'] = 73,
    ['f'] = 74,
    ['g'] = 75,
    ['h'] = 76,
    ['i'] = 77,
    ['j'] = 78,
    ['k'] = 79,
    ['l'] = 80,
    ['m'] = 81,
    ['n'] = 82,
    ['o'] = 83,
    ['p'] = 84,
    ['q'] = 85,
    ['r'] = 86,
    ['s'] = 87,
    ['t'] = 88,
    ['u'] = 89,
    ['v'] = 90,
    ['w'] = 91,
    ['x'] = 92,
    ['y'] = 93,
    ['z'] = 94,
    ['А'] = 95,
    ['Б'] = 96,
    ['В'] = 97,
    ['Г'] = 98,
    ['Д'] = 99,
    ['Е'] = 100,
    ['Ё'] = 101,
    ['Ж'] = 102,
    ['З'] = 103,
    ['И'] = 104,
    ['Й'] = 105,
    ['К'] = 106,
    ['Л'] = 107,
    ['М'] = 108,
    ['Н'] = 109,
    ['О'] = 110,
    ['П'] = 111,
    ['Р'] = 112,
    ['С'] = 113,
    ['Т'] = 114,
    ['У'] = 115,
    ['Ф'] = 116,
    ['Х'] = 117,
    ['Ц'] = 118,
    ['Ч'] = 119,
    ['Ш'] = 120,
    ['Щ'] = 121,
    ['Ъ'] = 122,
    ['Ы'] = 123,
    ['Ь'] = 124,
    ['Э'] = 125,
    ['Ю'] = 126,
    ['Я'] = 127,
    ['а'] = 128,
    ['б'] = 129,
    ['в'] = 130,
    ['г'] = 131,
    ['д'] = 132,
    ['е'] = 133,
    ['ё'] = 134,
    ['ж'] = 135,
    ['з'] = 136,
    ['и'] = 137,
    ['й'] = 138,
    ['к'] = 139,
    ['л'] = 140,
    ['м'] = 141,
    ['н'] = 142,
    ['о'] = 143,
    ['п'] = 144,
    ['р'] = 145,
    ['с'] = 146,
    ['т'] = 147,
    ['у'] = 148,
    ['ф'] = 149,
    ['х'] = 150,
    ['ц'] = 151,
    ['ч'] = 152,
    ['ш'] = 153,
    ['щ'] = 154,
    ['ъ'] = 155,
    ['ы'] = 156,
    ['ь'] = 157,
    ['э'] = 158,
    ['ю'] = 159,
    ['я'] = 160
}

charset.MESSAGE_DECODE = {
    [0] = ' ',
    [1] = '!',
    [2] = '"',
    [3] = '#',
    [4] = '$',
    [5] = '%',
    [6] = '&',
    [7] = '\'',
    [8] = '(',
    [9] = ')',
    [10] = '*',
    [11] = '+',
    [12] = ',',
    [13] = '-',
    [14] = '.',
    [15] = '/',
    [16] = ':',
    [17] = ';',
    [18] = '<',
    [19] = '=',
    [20] = '>',
    [21] = '?',
    [22] = '@',
    [23] = '[',
    [24] = '\\',
    [25] = ']',
    [26] = '^',
    [27] = '_',
    [28] = '`',
    [29] = '{',
    [30] = '|',
    [31] = '}',
    [32] = '~',
    [33] = '0',
    [34] = '1',
    [35] = '2',
    [36] = '3',
    [37] = '4',
    [38] = '5',
    [39] = '6',
    [40] = '7',
    [41] = '8',
    [42] = '9',
    [43] = 'A',
    [44] = 'B',
    [45] = 'C',
    [46] = 'D',
    [47] = 'E',
    [48] = 'F',
    [49] = 'G',
    [50] = 'H',
    [51] = 'I',
    [52] = 'J',
    [53] = 'K',
    [54] = 'L',
    [55] = 'M',
    [56] = 'N',
    [57] = 'O',
    [58] = 'P',
    [59] = 'Q',
    [60] = 'R',
    [61] = 'S',
    [62] = 'T',
    [63] = 'U',
    [64] = 'V',
    [65] = 'W',
    [66] = 'X',
    [67] = 'Y',
    [68] = 'Z',
    [69] = 'a',
    [70] = 'b',
    [71] = 'c',
    [72] = 'd',
    [73] = 'e',
    [74] = 'f',
    [75] = 'g',
    [76] = 'h',
    [77] = 'i',
    [78] = 'j',
    [79] = 'k',
    [80] = 'l',
    [81] = 'm',
    [82] = 'n',
    [83] = 'o',
    [84] = 'p',
    [85] = 'q',
    [86] = 'r',
    [87] = 's',
    [88] = 't',
    [89] = 'u',
    [90] = 'v',
    [91] = 'w',
    [92] = 'x',
    [93] = 'y',
    [94] = 'z',
    [95] = 'А',
    [96] = 'Б',
    [97] = 'В',
    [98] = 'Г',
    [99] = 'Д',
    [100] = 'Е',
    [101] = 'Ё',
    [102] = 'Ж',
    [103] = 'З',
    [104] = 'И',
    [105] = 'Й',
    [106] = 'К',
    [107] = 'Л',
    [108] = 'М',
    [109] = 'Н',
    [110] = 'О',
    [111] = 'П',
    [112] = 'Р',
    [113] = 'С',
    [114] = 'Т',
    [115] = 'У',
    [116] = 'Ф',
    [117] = 'Х',
    [118] = 'Ц',
    [119] = 'Ч',
    [120] = 'Ш',
    [121] = 'Щ',
    [122] = 'Ъ',
    [123] = 'Ы',
    [124] = 'Ь',
    [125] = 'Э',
    [126] = 'Ю',
    [127] = 'Я',
    [128] = 'а',
    [129] = 'б',
    [130] = 'в',
    [131] = 'г',
    [132] = 'д',
    [133] = 'е',
    [134] = 'ё',
    [135] = 'ж',
    [136] = 'з',
    [137] = 'и',
    [138] = 'й',
    [139] = 'к',
    [140] = 'л',
    [141] = 'м',
    [142] = 'н',
    [143] = 'о',
    [144] = 'п',
    [145] = 'р',
    [146] = 'с',
    [147] = 'т',
    [148] = 'у',
    [149] = 'ф',
    [150] = 'х',
    [151] = 'ц',
    [152] = 'ч',
    [153] = 'ш',
    [154] = 'щ',
    [155] = 'ъ',
    [156] = 'ы',
    [157] = 'ь',
    [158] = 'э',
    [159] = 'ю',
    [160] = 'я'
}

return charset