--[[
    Project: SAMP-API.lua <https://github.com/imring/SAMP-API.lua>
    Developers: imring, LUCHARE, FYP

    Special thanks:
        SAMemory (https://www.blast.hk/threads/20472/) for implementing the basic functions.
        SAMP-API (https://github.com/BlastHackNet/SAMP-API) for the structures and addresses.
]]

local sampapi = require 'sampapi'
local shared = sampapi.shared
local mt = require 'sampapi.metatype'
local ffi = require 'ffi'

local ScrSetPlayerSkillLevel = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xF5E0))
local ScrCreate3DTextLabel = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xF720))
local ScrDestroy3DTextLabel = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xF8D0))
local ScrChatBubble = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xF990))
local ScrShowDialog = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xFAF0))
local ScrSetCheckpoint = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x10170))
local ScrDisableCheckpoint = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xE5A0))
local ScrSetRaceCheckpoint = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x10280))
local ScrDisableRaceCheckpoint = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xE5B0))
local UpdateScoresPingsIps = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x103E0))
local SrvNetStats = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xE5C0))
local ScrGamemodeRestart = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xE650))
local ConnectionRejected = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x10540))
local ScrClientMessage = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xEF90))
local ScrSetWorldTime = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xEEF0))
local ScrCreatePickup = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xF080))
local ScrDestroyPickup = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xF140))
local ScrDestroyWeaponPickup = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xF1E0))
local ScmEvent = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xF280))
local ScrSetWeather = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xF370))
local ScrSetPlayerTime = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xF420))
local ScrToggleClock = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xF500))
local ScrSetIngameTimer = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xFF30))
local ScrWorldPlayerAdd = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x10B00))
local ScrWorldPlayerDeath = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x10D40))
local ScrWorldPlayerRemove = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x10E00))
local ScrWorldVehicleAdd = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xE670))
local ScrWorldVehicleRemove = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x10EE0))
local DamageVehicle = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x111C0))
local ScrSetVehicleParamsEx = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x112F0))
local EnterVehicle = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x115D0))
local ExitVehicle = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x116F0))
local ScrServerJoin = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xFCE0))
local ScrServerQuit = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xFE70))
local ScrInitGame = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x10660))
local Chat = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x122F0))
local RequestClass = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xFFD0))
local RequestSpawn = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x100A0))
local EditAttachedObject = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x117E0))
local EditObject = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x118A0))
local EnterEditObject = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xE8B0))
local ScrCancelEdit = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xE970))
local ScrUpdateCameraTarget = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xEA20))
local ClientCheck = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x11A60))
local ScrCreateActor = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0xEAB0))
local ScrDestroyActor = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x11E00))
local ScrDisableVehicleCollisions = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x17DE0))
local ScrSetPlayerMapIcon = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1A790))
local ScrRemovePlayerMapIcon = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1A8B0))
local ScrSetPlayerAmmo = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1AC10))
local ScrSetGravity = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1ACD0))
local ScrSetVehicleHealth = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1AD70))
local ScrAttachTrailerToVehicle = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1AE50))
local ScrDetachTrailerFromVehicle = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1AF90))
local ScrCreateObject = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1B340))
local ScrSetObjectPosition = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1BA10))
local ScrSetObjectRotation = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1BB20))
local ScrDestroyObject = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1BC20))
local ScrCreateExplosion = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1BD10))
local ScrShowPlayerNametagForPlayer = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1BE20))
local ScrMoveObject = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1BF00))
local ScrStopObject = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1C0B0))
local ScrSetNumberPlate = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1C230))
local ScrTogglePlayerSpectating = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1C350))
local ScrPlayerSpectatePlayer = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1C400))
local ScrPlayerSpectateVehicle = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1C4E0))
local ScrMoveVehicleComponent = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1C5C0))
local ScrForceClassSelection = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x180D0))
local ScrAttachObjectToPlayer = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1C6A0))
local ScrSetPlayerWantedLevel = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1CCF0))
local ScrShowTextDraw = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1CD90))
local ScrHideTextDrawForPlayer = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1CEC0))
local ScrTextDrawSetString = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1CF70))
local ScrGangZoneCreate = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1D080))
local ScrGangZoneDestroy = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1D1A0))
local ScrGangZoneFlash = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1D250))
local ScrGangZoneStopFlash = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1D310))
local ScrApplyAnimation = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1A950))
local ScrClearAnimations = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x18580))
local ScrSetPlayerSpecialAction = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x18690))
local ScrEnableStuntBonusForPlayer = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x17D50))
local ScrSetPlayerFightingStyle = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x18740))
local ScrSetPlayerVelocity = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x18850))
local ScrSetVehicleVelocity = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x18950))
local ScrPlayCrimeReport = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19050))
local ScrSetSpawnInfo = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x17F50))
local ScrSetPlayerTeam = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19710))
local ScrSetPlayerSkin = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19190))
local ScrSetPlayerName = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1DFD0))
local ScrSetPlayerPosition = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19320))
local ScrSetPlayerPositionFindZ = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19440))
local ScrSetPlayerHealth = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19550))
local ScrPutPlayerInVehicle = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19600))
local ScrRemovePlayerFromVehicle = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x17FF0))
local ScrSetPlayerColor = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19800))
local ScrDisplayGametext = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x198F0))
local ScrSetPlayerInterior = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19A00))
local ScrSetPlayerCameraPosition = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19AA0))
local ScrSetPlayerCameraLookAt = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19B70))
local ScrSetVehiclePosition = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19C70))
local ScrSetVehicleZAngle = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19D80))
local ScrSetVehicleParamsForPlayer = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19E60))
local ScrSetCameraBehindPlayer = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x18080))
local ScrTogglePlayerControllable = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1A290))
local ScrPlaySound = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1A330))
local ScrSetPlayerWorldBounds = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1A410))
local ScrGivePlayerMoney = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1A500))
local ScrSetPlayerFacingAngle = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1A5A0))
local ScrResetPlayerMoney = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x18090))
local ScrResetPlayerWeapons = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x180A0))
local ScrGivePlayerWeapon = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1A640))
local ScrLinkVehicleToInterior = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19F30))
local ScrSetPlayerArmor = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1AB60))
local ScrDeathMessage = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1DD70))
local ScrSetPlayerShopName = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x17E50))
local ScrSetPlayerDrunkLevel = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x18DB0))
local ScrSetPlayerArmedWeapon = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x18E50))
local ScrSetPlayerAttachedObject = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x18F00))
local ScrPlayAudioStream = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1D3C0))
local ScrStopAudioStream = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x180F0))
local ScrRemoveBuildingForPlayer = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1D530))
local ScrAttachCameraToObject = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x19FF0))
local ScrInterpolateCamera = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1A0F0))
local ClickTextDraw = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1D650))
local ScrSetObjectMaterial = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1B6A0))
local ScrStopObjectCameraCollision = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1C170))
local ScrSetActorAnimation = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1D750))
local ScrSetActorRotation = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1D9F0))
local ScrSetActorPosition = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1DAD0))
local ScrSetActorHealth = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1DBE0))
local ScrInitMenu = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1C870))
local ScrShowMenu = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1CB90))
local ScrHideMenu = ffi.cast('void(*)(SRPCParameters*)', sampapi.GetAddress(0x1CC40))

return {
    ScrSetPlayerSkillLevel = ScrSetPlayerSkillLevel,
    ScrCreate3DTextLabel = ScrCreate3DTextLabel,
    ScrDestroy3DTextLabel = ScrDestroy3DTextLabel,
    ScrChatBubble = ScrChatBubble,
    ScrShowDialog = ScrShowDialog,
    ScrSetCheckpoint = ScrSetCheckpoint,
    ScrDisableCheckpoint = ScrDisableCheckpoint,
    ScrSetRaceCheckpoint = ScrSetRaceCheckpoint,
    ScrDisableRaceCheckpoint = ScrDisableRaceCheckpoint,
    UpdateScoresPingsIps = UpdateScoresPingsIps,
    SrvNetStats = SrvNetStats,
    ScrGamemodeRestart = ScrGamemodeRestart,
    ConnectionRejected = ConnectionRejected,
    ScrClientMessage = ScrClientMessage,
    ScrSetWorldTime = ScrSetWorldTime,
    ScrCreatePickup = ScrCreatePickup,
    ScrDestroyPickup = ScrDestroyPickup,
    ScrDestroyWeaponPickup = ScrDestroyWeaponPickup,
    ScmEvent = ScmEvent,
    ScrSetWeather = ScrSetWeather,
    ScrSetPlayerTime = ScrSetPlayerTime,
    ScrToggleClock = ScrToggleClock,
    ScrSetIngameTimer = ScrSetIngameTimer,
    ScrWorldPlayerAdd = ScrWorldPlayerAdd,
    ScrWorldPlayerDeath = ScrWorldPlayerDeath,
    ScrWorldPlayerRemove = ScrWorldPlayerRemove,
    ScrWorldVehicleAdd = ScrWorldVehicleAdd,
    ScrWorldVehicleRemove = ScrWorldVehicleRemove,
    DamageVehicle = DamageVehicle,
    ScrSetVehicleParamsEx = ScrSetVehicleParamsEx,
    EnterVehicle = EnterVehicle,
    ExitVehicle = ExitVehicle,
    ScrServerJoin = ScrServerJoin,
    ScrServerQuit = ScrServerQuit,
    ScrInitGame = ScrInitGame,
    Chat = Chat,
    RequestClass = RequestClass,
    RequestSpawn = RequestSpawn,
    EditAttachedObject = EditAttachedObject,
    EditObject = EditObject,
    EnterEditObject = EnterEditObject,
    ScrCancelEdit = ScrCancelEdit,
    ScrUpdateCameraTarget = ScrUpdateCameraTarget,
    ClientCheck = ClientCheck,
    ScrCreateActor = ScrCreateActor,
    ScrDestroyActor = ScrDestroyActor,
    ScrDisableVehicleCollisions = ScrDisableVehicleCollisions,
    ScrSetPlayerMapIcon = ScrSetPlayerMapIcon,
    ScrRemovePlayerMapIcon = ScrRemovePlayerMapIcon,
    ScrSetPlayerAmmo = ScrSetPlayerAmmo,
    ScrSetGravity = ScrSetGravity,
    ScrSetVehicleHealth = ScrSetVehicleHealth,
    ScrAttachTrailerToVehicle = ScrAttachTrailerToVehicle,
    ScrDetachTrailerFromVehicle = ScrDetachTrailerFromVehicle,
    ScrCreateObject = ScrCreateObject,
    ScrSetObjectPosition = ScrSetObjectPosition,
    ScrSetObjectRotation = ScrSetObjectRotation,
    ScrDestroyObject = ScrDestroyObject,
    ScrCreateExplosion = ScrCreateExplosion,
    ScrShowPlayerNametagForPlayer = ScrShowPlayerNametagForPlayer,
    ScrMoveObject = ScrMoveObject,
    ScrStopObject = ScrStopObject,
    ScrSetNumberPlate = ScrSetNumberPlate,
    ScrTogglePlayerSpectating = ScrTogglePlayerSpectating,
    ScrPlayerSpectatePlayer = ScrPlayerSpectatePlayer,
    ScrPlayerSpectateVehicle = ScrPlayerSpectateVehicle,
    ScrMoveVehicleComponent = ScrMoveVehicleComponent,
    ScrForceClassSelection = ScrForceClassSelection,
    ScrAttachObjectToPlayer = ScrAttachObjectToPlayer,
    ScrSetPlayerWantedLevel = ScrSetPlayerWantedLevel,
    ScrShowTextDraw = ScrShowTextDraw,
    ScrHideTextDrawForPlayer = ScrHideTextDrawForPlayer,
    ScrTextDrawSetString = ScrTextDrawSetString,
    ScrGangZoneCreate = ScrGangZoneCreate,
    ScrGangZoneDestroy = ScrGangZoneDestroy,
    ScrGangZoneFlash = ScrGangZoneFlash,
    ScrGangZoneStopFlash = ScrGangZoneStopFlash,
    ScrApplyAnimation = ScrApplyAnimation,
    ScrClearAnimations = ScrClearAnimations,
    ScrSetPlayerSpecialAction = ScrSetPlayerSpecialAction,
    ScrEnableStuntBonusForPlayer = ScrEnableStuntBonusForPlayer,
    ScrSetPlayerFightingStyle = ScrSetPlayerFightingStyle,
    ScrSetPlayerVelocity = ScrSetPlayerVelocity,
    ScrSetVehicleVelocity = ScrSetVehicleVelocity,
    ScrPlayCrimeReport = ScrPlayCrimeReport,
    ScrSetSpawnInfo = ScrSetSpawnInfo,
    ScrSetPlayerTeam = ScrSetPlayerTeam,
    ScrSetPlayerSkin = ScrSetPlayerSkin,
    ScrSetPlayerName = ScrSetPlayerName,
    ScrSetPlayerPosition = ScrSetPlayerPosition,
    ScrSetPlayerPositionFindZ = ScrSetPlayerPositionFindZ,
    ScrSetPlayerHealth = ScrSetPlayerHealth,
    ScrPutPlayerInVehicle = ScrPutPlayerInVehicle,
    ScrRemovePlayerFromVehicle = ScrRemovePlayerFromVehicle,
    ScrSetPlayerColor = ScrSetPlayerColor,
    ScrDisplayGametext = ScrDisplayGametext,
    ScrSetPlayerInterior = ScrSetPlayerInterior,
    ScrSetPlayerCameraPosition = ScrSetPlayerCameraPosition,
    ScrSetPlayerCameraLookAt = ScrSetPlayerCameraLookAt,
    ScrSetVehiclePosition = ScrSetVehiclePosition,
    ScrSetVehicleZAngle = ScrSetVehicleZAngle,
    ScrSetVehicleParamsForPlayer = ScrSetVehicleParamsForPlayer,
    ScrSetCameraBehindPlayer = ScrSetCameraBehindPlayer,
    ScrTogglePlayerControllable = ScrTogglePlayerControllable,
    ScrPlaySound = ScrPlaySound,
    ScrSetPlayerWorldBounds = ScrSetPlayerWorldBounds,
    ScrGivePlayerMoney = ScrGivePlayerMoney,
    ScrSetPlayerFacingAngle = ScrSetPlayerFacingAngle,
    ScrResetPlayerMoney = ScrResetPlayerMoney,
    ScrResetPlayerWeapons = ScrResetPlayerWeapons,
    ScrGivePlayerWeapon = ScrGivePlayerWeapon,
    ScrLinkVehicleToInterior = ScrLinkVehicleToInterior,
    ScrSetPlayerArmor = ScrSetPlayerArmor,
    ScrDeathMessage = ScrDeathMessage,
    ScrSetPlayerShopName = ScrSetPlayerShopName,
    ScrSetPlayerDrunkLevel = ScrSetPlayerDrunkLevel,
    ScrSetPlayerArmedWeapon = ScrSetPlayerArmedWeapon,
    ScrSetPlayerAttachedObject = ScrSetPlayerAttachedObject,
    ScrPlayAudioStream = ScrPlayAudioStream,
    ScrStopAudioStream = ScrStopAudioStream,
    ScrRemoveBuildingForPlayer = ScrRemoveBuildingForPlayer,
    ScrAttachCameraToObject = ScrAttachCameraToObject,
    ScrInterpolateCamera = ScrInterpolateCamera,
    ClickTextDraw = ClickTextDraw,
    ScrSetObjectMaterial = ScrSetObjectMaterial,
    ScrStopObjectCameraCollision = ScrStopObjectCameraCollision,
    ScrSetActorAnimation = ScrSetActorAnimation,
    ScrSetActorRotation = ScrSetActorRotation,
    ScrSetActorPosition = ScrSetActorPosition,
    ScrSetActorHealth = ScrSetActorHealth,
    ScrInitMenu = ScrInitMenu,
    ScrShowMenu = ScrShowMenu,
    ScrHideMenu = ScrHideMenu,
}